【POJ3621】Sightseeing Cows

Sightseeing Cows

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 8331   Accepted: 2791

Description

Farmer John has decided to reward his cows for their hard work by taking them on a tour of the big city! The cows must decide how best to spend their free time.

Fortunately, they have a detailed city map showing the L (2 ≤ L ≤ 1000) major landmarks (conveniently numbered 1.. L) and the P (2 ≤ P ≤ 5000) unidirectional cow paths that join them. Farmer John will drive the cows to a starting landmark of their choice, from which they will walk along the cow paths to a series of other landmarks, ending back at their starting landmark where Farmer John will pick them up and take them back to the farm. Because space in the city is at a premium, the cow paths are very narrow and so travel along each cow path is only allowed in one fixed direction.

While the cows may spend as much time as they like in the city, they do tend to get bored easily. Visiting each new landmark is fun, but walking between them takes time. The cows know the exact fun values Fi (1 ≤ Fi ≤ 1000) for each landmark i.

The cows also know about the cowpaths. Cowpath i connects landmark L1i to L2i (in the direction L1i -> L2i ) and requires time Ti (1 ≤ Ti ≤ 1000) to traverse.

In order to have the best possible day off, the cows want to maximize the average fun value per unit time of their trip. Of course, the landmarks are only fun the first time they are visited; the cows may pass through the landmark more than once, but they do not perceive its fun value again. Furthermore, Farmer John is making the cows visit at least two landmarks, so that they get some exercise during their day off.

Help the cows find the maximum fun value per unit time that they can achieve.

Input

* Line 1: Two space-separated integers: L and P
* Lines 2..L+1: Line i+1 contains a single one integer: Fi
* Lines L+2..L+P+1: Line L+i+1 describes cow path i with three space-separated integers: L1i , L2i , and Ti

Output

* Line 1: A single number given to two decimal places (do not perform explicit rounding), the maximum possible average fun per unit time, or 0 if the cows cannot plan any trip at all in accordance with the above rules.

Sample Input

5 7
30
10
10
5
10
1 2 3
2 3 2
3 4 5
3 5 2
4 5 5
5 1 3
5 2 2

Sample Output

6.00

题意:给出一个有向图 问求一个回路 使得回路上的点权之和/边权之和最大

01分数规划,简单构造,将点权转移到边权上~因为一个环上的点和边的数量是相等的~

设i,j之间初始边权为w[i][j],修改后的边权为g[i][j],则g[i][j]=w[i][j]*mid+val[i]

spfa判负环即可~

其实说起来很简单写的时候好烦。。。。因为G++%lf输出问题WA了好多次。。。

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <cstdlib>
 5 #include <algorithm>
 6 #include <cmath>
 7 using namespace std;
 8
 9 const int maxn = 1010;
10 const int maxm = 1000010;
11 int a[maxm], b[maxm];
12 int head[maxn], next[maxm], to[maxm];
13 int q[maxn*5], im[maxm];
14 int vis[maxn];
15 int cnt, st;
16 int n, m;
17 double l, r, mid;
18 double c[maxm], dis[maxn], len[maxm], val[maxn];
19
20 inline void add(int u, int v, double w);
21 bool dfs(int u);
22 bool spfa();
23
24 int main(){
25     while(scanf("%d%d", &n, &m)!=EOF){
26         for(int i = 1; i <= n; ++i){
27             scanf("%lf", &val[i]);
28         }
29
30         memset(head, -1, sizeof(head));
31         cnt = 0;
32         for(int i = 1; i <= m; ++i){
33             scanf("%d%d%lf", &a[i], &b[i], &c[i]);
34             add(a[i], b[i], c[i]);
35         }
36
37         l = 0.0;
38         r = 1000.0;
39         while(r-l > 1e-4){
40             mid = (r+l) / 2.0;
41             if(spfa()){
42                 l = mid;
43             }
44             else{
45                 r = mid;
46             }
47         }
48         printf("%.2f\n", mid);
49     }
50     return 0;
51 }
52
53 inline void add(int u, int v, double w){
54     to[cnt] = v;
55     len[cnt] = w;
56     next[cnt] = head[u];
57     head[u] = cnt++;
58 }
59
60 bool dfs(int u){
61     vis[u] = st;
62     for(int i = head[u]; ~i; i = next[i]){
63         if(dis[to[i]] > dis[u] + len[i]*mid - val[u]){
64             dis[to[i]] = dis[u] + len[i]*mid - val[u];
65             if(vis[to[i]] == st){
66                 return true;
67             }
68             else if(dfs(to[i])){
69                 return true;
70             }
71         }
72     }
73     vis[u] = 0;
74     return false;
75 }
76
77 bool spfa(){
78     memset(vis, 0, sizeof(vis));
79     for(st = 1; st <= n; ++st){
80         if(dfs(st)){
81             return true;
82         }
83     }
84     return false;
85 }
时间: 2025-01-05 23:16:13

【POJ3621】Sightseeing Cows的相关文章

【POJ3621】Sightseeing Cows 分数规划

[POJ3621]Sightseeing Cows 题意:在给定的一个图上寻找一个环路,使得总欢乐值(经过的点权值之和)/ 总时间(经过的边权值之和)最大. 题解:显然是分数规划,二分答案ans,将每条边的权值变成(ans*边权-2*起始点点权),然后我们希望找出一个环,使得环上的总边权<0 (一开始我把题意理解错了,题中给的是单向边,我把它当成是双向边+每条边只能走一次了~,想出一堆做法都接连pass掉) 然后就直接用SPFA判负环就好了嘛!由于原图不一定联通,所以一开始就把所有点都入队就完事

【POJ 3621】Sightseeing Cows

Sightseeing Cows Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 7984   Accepted: 2685 Description Farmer John has decided to reward his cows for their hard work by taking them on a tour of the big city! The cows must decide how best to

【POJ】【1637】Sightseeing tour

网络流/最大流 愚人节快乐XD 这题是给一个混合图(既有有向边又有无向边),让你判断是否有欧拉回路…… 我们知道如果一个[连通]图中每个节点都满足[入度=出度]那么就一定有欧拉回路…… 那么每条边都可以贡献一个出度出来,对于一条边u->v: 连S->edge cap=1; 如果是有向边,就连 edge->v cap=1; 否则(无向边)连edge->u cap=1, edge->v cap=1; 然后每个点的总度数我们是知道的……那么它最后的[出度]就等于 总度数/2.(这个

【图论】Popular Cows

[POJ2186]Popular Cows Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 34752   Accepted: 14155 Description Every cow's dream is to become the most popular cow in the herd. In a herd of N (1 <= N <= 10,000) cows, you are given up to M (1

【POJ1637】Sightseeing tour

Description The city executive board in Lund wants to construct a sightseeing tour by bus in Lund, so that tourists can see every corner of the beautiful city. They want to construct the tour so that every street in the city is visited exactly once.

【POJ1637】Sightseeing tour 混合图求欧拉回路存在性 网络流、

题意:多组数据,最后的0/1表示0无向1有向. 问是否存在欧拉回路. 题解:无向边给它任意定个向. 首先欧拉回路中点入度=出度. 然后发现每个无向边如果修改个方向,原来的入点的入度+1,出度-1,出点反之. 然后我们不妨对入度和出度不同的点跟源汇中之一连边,容量为入出度差一半(每改一条边差-2) 然后原来的无向边联系图中各点,容量1,最后check if(maxflow==sum差/4). 这都没看懂的弱菜们不妨出度多的连源,入度多的连汇,容量为入出度差一半,然后按无向边的定向给它在网络流图中定

【poj3621】最优比率环

题意: 给定n个点,每个点有一个开心度F[i],每个点有m条单向边,每条边有一个长度d,要求一个环,使得它的 开心度的和/长度和 这个比值最大.n<=1000,m<=5000 题解: 最优比率环,很像以前做过的一题最优比率生成树.首先二分一个答案r=sigma(xi*fi)/sigma(xi*di),设z=r*sigma(xi*di)-sigma(xi*fi),若能找到一个环满足z<=0,则代表sigma(xi*fi)>=r*sigma(xi*di),则r可以比当前的r要大,则l=

【poj2186】Popular Cows

传送门 tarjan缩点后是个DAG,然后只有一个出度为0的点的话就输出该点的大小,否则为0. 1 #include<cstdio> 2 #define repu(i,x,y) for(i=x;i<=y;i++) 3 #define min(a,b) (a<b?a:b) 4 #define N 50001 5 struct edge{ 6 int v; 7 edge *next; 8 }e[N],*tp=e,*first[N]; 9 int dfn[N],low[N],a[N],f

【USACO】milking cows

{ ID: anniel11 PROG: milk2 LANG: PASCAL } Program milk2; Var ans1,ans2,i,j,n,sum,head,tail:longint; a:array[1..5000,1..2] of longint; map:array[1..100000] of integer; f:array[0..100000,1..2] of integer; Begin fillchar(map,sizeof(map),0); ans1:=0; ans